//
//  CompaniesDetailController.m
//  BMXMDB
//
//  Created by Nick Hayday on 22/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CompaniesDetailController.h"

@implementation CompaniesDetailController

@synthesize companyLabel, filmView, scrollView, company, companiesFilms, activityView, spinner;

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = company.companyName; 
    
    FMDBDataAccess *db = [[FMDBDataAccess alloc] init];
    
    self.companiesFilms = [db getCompaniesFilms:company.companyID];
    
    [filmView reloadData];
    
}

- (void)viewDidAppear:(BOOL)animated {
    
    //    logo code
    
    NSString *path = [[NSBundle mainBundle] pathForResource:[NSString stringWithFormat:@"%d", company.companyID] ofType:@"png" inDirectory:@"images/companies/full"];
    
    if([path length] >0) {
    
        UIImage *theImage = [UIImage imageWithContentsOfFile:path];
    
        UIImageView *imageView = [[UIImageView alloc] initWithImage:theImage];
    
        [self.scrollView addSubview:imageView];
        
        
        
    }
    
    CGRect tableFrame = filmView.frame;
    tableFrame.size.height = filmView.contentSize.height;
    
    if([path length] >0) {
    
        tableFrame.origin = CGPointMake(0, 320.0); // set origin if image exists to push down the tableview
        
    }
    
    filmView.frame = tableFrame;
    
    scrollView.contentSize = CGSizeMake(tableFrame.size.width, filmView.frame.origin.y + filmView.frame.size.height);
    
    filmView.scrollsToTop = NO;
    scrollView.scrollsToTop = YES;
    
    [spinner stopAnimating];
    [activityView setHidden:YES];
    
    
}

- (void)viewWillAppear:(BOOL)animated {
    
    spinner.hidesWhenStopped = YES;
    
    [spinner startAnimating];
    
    [filmView deselectRowAtIndexPath:[filmView indexPathForSelectedRow] animated:animated];
    
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return [companiesFilms count];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
        
    static NSString *MyIdentifier = @"MyIdentifier";
	MyIdentifier = @"CompDetailTblCellView";
	
	CompanyDetailTableCellView *cell = (CompanyDetailTableCellView *)[tableView dequeueReusableCellWithIdentifier:MyIdentifier];
	if(cell == nil) {
		[[NSBundle mainBundle] loadNibNamed:@"CompanyDetailTableCellView" owner:self options:nil];
		cell = tblCell;
	}

    
    Film *film = [companiesFilms objectAtIndex:indexPath.row];
    
    [cell setTitleText:[NSString stringWithFormat:@"%@",film.filmName]];
    
    NSMutableString *formats = [NSMutableString stringWithFormat:@""];
    
    if (film.format_vhs != 0){
        [formats appendString:@"VHS "];
    }
    if (film.format_dvd != 0){
        [formats appendString:@"DVD "];
    }
    if (film.format_web != 0){
        [formats appendString:@"Web "];
    }
    if (film.format_blu != 0){
        [formats appendString:@"Blu-Ray "];
    }
    
    
    if (film.year != 0) {
        [cell  setYearText:[NSString stringWithFormat:@"Year:%d", film.year]];
        
    } else {
        [cell setYearText:[NSString stringWithFormat:@"Year:(Unknown)"]];
    }
    
    [cell setCover:[NSString stringWithFormat:@"%d",film.filmID]];
    
    [cell setCompanyText:film.companies];
    
    return cell;
    
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    FilmsDetailController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"FilmDetail"];
    
    Film *filmObj = [companiesFilms objectAtIndex:indexPath.row];
    
    detail.film = filmObj;
    
    [self.navigationController pushViewController:detail animated:YES];

}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    return 60.0;
    
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    return @"Films";
}

@end
