//
//  CompaniesViewController.m
//  BMXMDB
//
//  Created by Nick Hayday on 22/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CompaniesViewController.h"

@implementation CompaniesViewController

@synthesize company, companySearch, searchResults;

- (void)loadView {
    [super loadView];
    
    [self populateCompanies];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.tableView.contentOffset = CGPointMake(0.0, 44.0);
    
    self.navigationController.navigationBar.barStyle=UIBarStyleBlackOpaque;
    
    searching = NO;
    
}

-(void) populateCompanies 
{
    self.company = [[NSMutableArray alloc] init];
    self.searchResults = [[NSMutableArray alloc] init];
    
    FMDBDataAccess *db = [[FMDBDataAccess alloc] init];
    
    self.company = [db getSectionedCompanies];
    
    self.companySearch = [db getCompanies];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    if (searching)
		return 1;
	else
        return [self.company count];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    CompaniesDetailController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"CompaniesDetail"];
    
    NSMutableArray *section = [self.company objectAtIndex:indexPath.section];
    
    Company *c;
    
    if (searching){
        c = [searchResults objectAtIndex:indexPath.row];
    }else {
        c = [section objectAtIndex:indexPath.row];
    }
    
    detail.company = c;
    
    [self.navigationController pushViewController:detail animated:YES];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    
    NSMutableArray *temp = [self.company objectAtIndex:section];
    
    
    if (searching)
		return [searchResults count];
	else
        return [temp count];
}

- (NSInteger)tableView:(UITableView *)tv sectionForSectionIndexTitle:(NSString *)title atIndex:(NSInteger)index {
    NSInteger section = -1;
    if ([title isEqualToString:UITableViewIndexSearch]) {
        CGRect searchBarFrame = self.searchDisplayController.searchBar.frame;
        [tv scrollRectToVisible:searchBarFrame animated:NO];
    }
    else {
        
        section = index - 1;
    }
    return section;
}

- (NSArray *)sectionIndexTitlesForTableView:(UITableView *)tableView {
    
    NSArray *searchArray = [NSArray arrayWithObjects:
                            UITableViewIndexSearch,@"A", @"B", @"C", @"D", @"E", @"F", @"G", @"H", @"I", @"J", @"K", @"L",
                            @"M", @"N", @"O", @"P", @"Q", @"R", @"S", @"T", @"U", @"V", @"W", @"X", @"Y", @"Z", @"#", nil];
    if (searching) 
        return nil;
    else
        return searchArray;
    
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    
    NSArray *searchArray = [NSArray arrayWithObjects:
                            @"A", @"B", @"C", @"D", @"E", @"F", @"G", @"H", @"I", @"J", @"K", @"L",
                            @"M", @"N", @"O", @"P", @"Q", @"R", @"S", @"T", @"U", @"V", @"W", @"X", @"Y", @"Z", @"#", nil];
    
    if (searching) 
        return nil;
    else
        return [searchArray objectAtIndex:section];
    
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{

    static NSString *MyIdentifier = @"MyIdentifier";
	MyIdentifier = @"CompanyTblCellView";
	
	CompanyTableCellView *cell = (CompanyTableCellView *)[tableView dequeueReusableCellWithIdentifier:MyIdentifier];
	if(cell == nil) {
		[[NSBundle mainBundle] loadNibNamed:@"CompanyTableCellView" owner:self options:nil];
		cell = tblCell;
	}

    
    if(searching){
        
        Company *temp2 = [searchResults objectAtIndex:indexPath.row];
        
        [cell setTitleText:[NSString stringWithFormat:@"%@",temp2.companyName]];
        
        [cell setCover:[NSString stringWithFormat:@"%d",temp2.companyID]];
		
    } else {
        
        
        NSMutableArray *temp = [self.company objectAtIndex:[indexPath section]];
        
        Company *companyTemp = [temp objectAtIndex:[indexPath row]];
        
        [cell setTitleText:[NSString stringWithFormat:@"%@",companyTemp.companyName]];
        
        [cell setCover:[NSString stringWithFormat:@"%d",companyTemp.companyID]];
        
    }
    
    return cell;
}

- (BOOL)searchDisplayController:(UISearchDisplayController *)controller shouldReloadTableForSearchString:(NSString *)searchString
{
    
    searching = YES;
    
    Company *temp;
    int searchLen = [searchString length];
    
    [searchResults removeAllObjects];
    
    
    for (temp in self.companySearch) {
        
        
        //test length of film name before testing substring
        
        if (!(searchLen > [temp.companyName length])){
            
            if (!([searchString compare:[temp.companyName substringToIndex:searchLen] options:NSCaseInsensitiveSearch  ])) {
                
                [self.searchResults addObject:temp];
                
                
            }
        }
        
        
    }
    
    [self.searchDisplayController.searchResultsTableView reloadData];
    
    return NO;
    
}

- (void)searchDisplayController:(UISearchDisplayController *)controller willUnloadSearchResultsTableView:(UITableView *)tableView
{
    searching = NO;
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    return 60.0;
    
}



@end
