//
//  FilmSectionViewController.m
//  BMXMDB
//
//  Created by Nick Hayday on 23/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "FilmSectionViewController.h"

@implementation FilmSectionViewController

@synthesize myWebView, section, rowNum, counter, ridersView, sectionsRiders, scrollView, sectionsSongs, songsView,activityView, spinner;


- (void)loadView {
    [super loadView];
    
    FMDBDataAccess *db = [[FMDBDataAccess alloc] init];
    
    sectionsRiders = [db getSectionsRiders:[section sectionID]];
    
    sectionsSongs = [db getSectionsSongs:[section sectionID]];
    
}


- (void)viewDidLoad {
    
    [super viewDidLoad];
    
    
// apply texture to element, should make elements see through, and view underneath apply the texture
//    [ridersView setBackgroundColor:[UIColor underPageBackgroundColor]];
    
    
    
    [myWebView setDelegate:self];
    
    counter = 0;
    
    self.rowNum.text = section.sectionName;
    
    NSString *baseURL = @"http://bmxmdb.com/app/";
    baseURL = [baseURL stringByAppendingString:[NSString stringWithFormat:@"%d",section.sectionID]];
    NSString *vidSize = @"/270";
    NSString *urlAddress = [baseURL stringByAppendingString:vidSize];
    
    //Create a URL object.
    NSURL *url = [NSURL URLWithString:urlAddress];
    
    //URL Requst Object
    NSURLRequest *requestObj = [NSURLRequest requestWithURL:url];
    
    //Load the request in the UIWebView.
    [myWebView loadRequest:requestObj];
    
    
    myWebView.scrollView.bounces = NO;
    
    [spinner stopAnimating];
    
    [activityView setHidden:YES];
    
}

- (void) viewDidAppear:(BOOL)animated {
    
    ridersView.bounces = NO;
    songsView.bounces = NO;
    
    CGRect tableFrame1 = ridersView.frame;
    tableFrame1.size.height = ridersView.contentSize.height;
    
    tableFrame1.origin = CGPointMake(0, 280.0); 
    
    ridersView.frame = tableFrame1;
    
    CGRect tableFrame = songsView.frame;
    tableFrame.size.height = songsView.contentSize.height;
    
    tableFrame.origin = CGPointMake(0, ridersView.frame.origin.y + ridersView.frame.size.height);
    
    songsView.frame = tableFrame;
    
    
    
    scrollView.contentSize = CGSizeMake(tableFrame1.size.width, ridersView.frame.origin.y + ridersView.frame.size.height + songsView.frame.size.height);
    
    
    
}

- (void)viewWillAppear:(BOOL)animated {
    [ridersView deselectRowAtIndexPath:[ridersView indexPathForSelectedRow] animated:animated];

    [super viewWillAppear:animated];
    
    spinner.hidesWhenStopped = YES;
    
    [spinner startAnimating];
}



- (void)webViewDidStartLoad:(UIWebView *)webView {
    self.counter++;
    [[UIApplication sharedApplication]
     setNetworkActivityIndicatorVisible:YES];
}



- (void)webViewDidFinishLoad:(UIWebView *)webView {
    self.counter--;
    
    if (self.counter == 0) //balances web requests, hide UIView loading sheet here
        [[UIApplication sharedApplication]
         setNetworkActivityIndicatorVisible:NO];
}


- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error {
    [[UIApplication sharedApplication]
     setNetworkActivityIndicatorVisible:NO];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    if (tableView.tag == 1) {
    
    static NSString *CellIdentifier = @"SectionRiderCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    People *person = [sectionsRiders objectAtIndex:indexPath.row];
    
    [[cell textLabel] setText:[person peopleName]];
    
    return cell;
        
    } else {
        static NSString *CellIdentifier = @"SongsCell";
        
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
        if (cell == nil) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
        }
        
        Song *s = [sectionsSongs objectAtIndex:indexPath.row];
        
        [[cell textLabel] setText:[s songName]];
        [[cell detailTextLabel] setText:[s songArtist]];
        
        return cell;
    }
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    if (tableView.tag == 1)
         return [sectionsRiders count];
    else 
        return [sectionsSongs count];
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    
    if (tableView.tag == 1)
        return @"Riders";
    else
        return @"Songs";
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
     if (tableView.tag == 1) {
         PeopleDetailController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"PeopleDetail"];
    
         People *p;
    
         p = [sectionsRiders objectAtIndex:indexPath.row];
    
         detail.person = p;
    
         [self.navigationController pushViewController:detail animated:YES];
         
     }
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (tableView.tag == 1)
        return 44.0;
    else 
        return 55.0;
    
}

// below makes header section text black

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section {
    return 44.0;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section1 {
    
    
    // create the parent view that will hold header Label
	UIView* customView = [[UIView alloc] initWithFrame:CGRectMake(20.0, 0.0, 300.0, 44.0)];
	
	// create the button object
	UILabel * headerLabel = [[UILabel alloc] initWithFrame:CGRectZero];
	headerLabel.backgroundColor = [UIColor clearColor];
	headerLabel.opaque = NO;
	headerLabel.textColor = [UIColor blackColor];
	headerLabel.highlightedTextColor = [UIColor whiteColor];
	headerLabel.font = [UIFont boldSystemFontOfSize:17];
	headerLabel.frame = CGRectMake(10.0, 0.0, 300.0, 44.0);
    
	headerLabel.text = [tableView.dataSource tableView:tableView titleForHeaderInSection:section1];
	[customView addSubview:headerLabel];
    
	return customView;
    
}




@end
