//
//  FilmsDetailController.m
//  BMXMDB
//
//  Created by Nick Hayday on 22/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "FilmsDetailController.h"

@implementation FilmsDetailController

@synthesize companyView, sectionView, filmLabel, scrollView, film, companiesFilms, filmsSections, filmYear, filmCountry, filmFormats, filmRuntime;

- (void) viewDidLoad {
    
    self.filmLabel.text = film.filmName;
    
    self.title = film.filmName;
    
    self.filmYear.text = [film getYear];
    
    self.filmCountry.text = [film getCountry];
    
    self.filmRuntime.text = [film getRuntime];
    
    self.filmFormats.text = [film getFormat];
    
    FMDBDataAccess *db = [[FMDBDataAccess alloc] init];
    
    companiesFilms = [db getFilmsCompanies:[film filmID]];
    
    filmsSections = [db getFilmsSections:[film filmID]];
    
    [filmLabel setHidden:TRUE];
    [filmYear setHidden:TRUE];
    [filmCountry setHidden:TRUE];
    [filmRuntime setHidden:TRUE];
    [filmFormats setHidden:TRUE];
    [companyView setHidden:TRUE];
    [sectionView setHidden:TRUE];

}

- (void)viewWillAppear:(BOOL)animated {
    [companyView deselectRowAtIndexPath:[companyView indexPathForSelectedRow] animated:animated];
    [sectionView deselectRowAtIndexPath:[sectionView indexPathForSelectedRow] animated:animated];
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated {
    
    NSString *path = [[NSBundle mainBundle] pathForResource:[NSString stringWithFormat:@"%d", film.filmID] ofType:@"jpg" inDirectory:@"images/covers/full"];
    
    UIImage *theImage;
    UIImageView *imageView;
    NSInteger originOffset;
    
    
    if([path length] >0) {
        theImage = [UIImage imageWithContentsOfFile:path];
        imageView = [[UIImageView alloc] initWithImage:theImage];
        [self.scrollView addSubview:imageView];
    }
    
    originOffset = imageView.frame.size.height + 10.0;
    
    CGRect labelFrame = filmLabel.frame;
    labelFrame.size.height = filmLabel.frame.size.height;
    labelFrame.origin = CGPointMake(10.0, originOffset);
    filmLabel.frame = labelFrame;
    
    
    originOffset = originOffset + filmLabel.frame.size.height;
        
    
    CGRect yearFrame = filmYear.frame;
    yearFrame.size.height = filmYear.frame.size.height;
    yearFrame.origin = CGPointMake(28.0, originOffset);
    filmYear.frame = yearFrame;
    
    if ([film getYear]) {
    
    originOffset = originOffset + filmYear.frame.size.height;
        
    }
    
    CGRect countryFrame = filmCountry.frame;
    countryFrame.size.height = filmCountry.frame.size.height;
    countryFrame.origin = CGPointMake(28.0, originOffset);
    filmCountry.frame = countryFrame;
    
    if ([film getCountry]) {
    
    originOffset = originOffset + filmCountry.frame.size.height;
        
    }
    
    CGRect formatFrame = filmFormats.frame;
    formatFrame.size.height = filmFormats.frame.size.height;
    formatFrame.origin = CGPointMake(28.0, originOffset);
    filmFormats.frame = formatFrame;
    
    if ([film getFormat]) {
    
    originOffset = originOffset + filmFormats.frame.size.height;
        
    }
    
    CGRect runtimeFrame = filmRuntime.frame;
    runtimeFrame.size.height = filmRuntime.frame.size.height;
    runtimeFrame.origin = CGPointMake(28.0, originOffset);
    filmRuntime.frame = runtimeFrame;
    
    if ([film getRuntime]) {
    
    originOffset = originOffset + filmRuntime.frame.size.height;
    
    }
    
    companyView.bounces = NO;
    
    CGRect tableFrame1 = companyView.frame;
    tableFrame1.size.height = companyView.contentSize.height;
    
    
        
    tableFrame1.origin = CGPointMake(0, originOffset - 10.0); // set origin if image exists to push down the tableview
        
    
    
    companyView.frame = tableFrame1;
    
    sectionView.bounces = NO;
    
    CGRect tableFrame = sectionView.frame;
    
    tableFrame.origin = CGPointMake(0.0, companyView.frame.origin.y + companyView.frame.size.height);
    
    tableFrame.size.height = sectionView.contentSize.height;
    sectionView.frame = tableFrame;
    
    scrollView.contentSize = CGSizeMake(tableFrame.size.width, sectionView.frame.origin.y + sectionView.frame.size.height);
    
    [filmLabel setHidden:FALSE];
    [filmYear setHidden:FALSE];
    [filmCountry setHidden:FALSE];
    [filmRuntime setHidden:FALSE];
    [filmFormats setHidden:FALSE];
    [companyView setHidden:FALSE];
    [sectionView setHidden:FALSE];
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    if (tableView.tag == 1) { //companyView
        
    
    static NSString *CellIdentifier = @"FilmCompanyCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    Company *comp = [companiesFilms objectAtIndex:indexPath.row];
    
    [[cell textLabel] setText:[comp companyName]];
    
    return cell;
        
    } else {
        
        static NSString *CellIdentifier = @"FilmSectionCell";
        
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
        if (cell == nil) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
        }
        
        FilmSections *comp = [filmsSections objectAtIndex:indexPath.row];
        
        [[cell textLabel] setText:[comp sectionName]];
        
        // add no video icon if [comp mobile] = 1
        
        if ([comp mobile] == 1) {
        
            NSString *img = @"nomobile";
        
            NSString *path = [[NSBundle mainBundle] pathForResource:[NSString stringWithFormat:@"%@", img] ofType:@"png" inDirectory:@"images/covers/full"];
            UIImage *theImage;
            UIImageView *imageView;
            theImage = [UIImage imageWithContentsOfFile:path];
            imageView = [[UIImageView alloc] initWithImage:theImage];
            
            CGRect imageFrame = imageView.frame;
            
            imageFrame.origin = CGPointMake(270.0, 8.0);
            imageView.frame = imageFrame;
        
            [cell addSubview:imageView];
            
        }
        
        return cell;
        
        
    }
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    if (tableView.tag == 1)
        return [companiesFilms count];
    else
        return [filmsSections count];
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    
    if (tableView.tag == 1)
        return @"Company";
    else
        return @"Sections";
    
    
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (tableView.tag == 1) {
    
        CompaniesDetailController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"CompaniesDetail"];
    
        Company *comp = [companiesFilms objectAtIndex:indexPath.row];
    
        detail.company = comp;
        
        [self.navigationController pushViewController:detail animated:YES];
        
    } else {
        
        FilmSectionViewController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"SectionDetail"];

        
        
        FilmSections *comp = [filmsSections objectAtIndex:indexPath.row];
        
        detail.section = comp;
        
        
        
        [self.navigationController pushViewController:detail animated:YES];
        
        
        
    }
    
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section {
    return 44.0;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
    
    
    // create the parent view that will hold header Label
	UIView* customView = [[UIView alloc] initWithFrame:CGRectMake(20.0, 0.0, 300.0, 44.0)];
	
	// create the button object
	UILabel * headerLabel = [[UILabel alloc] initWithFrame:CGRectZero];
	headerLabel.backgroundColor = [UIColor clearColor];
	headerLabel.opaque = NO;
	headerLabel.textColor = [UIColor blackColor];
	headerLabel.highlightedTextColor = [UIColor whiteColor];
	headerLabel.font = [UIFont boldSystemFontOfSize:17];
	headerLabel.frame = CGRectMake(10.0, 0.0, 300.0, 44.0);
    
	headerLabel.text = [tableView.dataSource tableView:tableView titleForHeaderInSection:section];
	[customView addSubview:headerLabel];
    
	return customView;
    
}



@end
