//
//  FilmsViewController.m
//  BMXMDB
//
//  Created by Nick Hayday on 21/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "FilmsViewController.h"

@implementation FilmsViewController

@synthesize films, filmSearch, searchResults;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)loadView {
    [super loadView];
    
    [self populateFilms];

}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.tableView.contentOffset = CGPointMake(0.0, 44.0);
    
    self.navigationController.navigationBar.barStyle=UIBarStyleBlackOpaque;
    
    searching = NO;

}



- (void)viewDidUnload
{
    [super viewDidUnload];
    
}

-(void) populateFilms 
{
    films = [[NSMutableArray alloc] init];
    searchResults = [[NSMutableArray alloc] init];
    
    FMDBDataAccess *db = [[FMDBDataAccess alloc] init];
    
    films = [db getSectionedFilms];
    
    filmSearch = [db getFilms];
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    if (searching)
		return 1;
	else
        return [films count];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    FilmsDetailController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"FilmDetail"];
    
    NSMutableArray *section = [films objectAtIndex:indexPath.section];
    
    Film *c;
    
    if (searching){
        c = [searchResults objectAtIndex:indexPath.row];
    }else {
        c = [section objectAtIndex:indexPath.row];
    }
    
    detail.film = c;
    
    [self.navigationController pushViewController:detail animated:YES];
    
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    
    NSMutableArray *temp = [films objectAtIndex:section];
    
    
    
    if (searching)
		return [searchResults count];
	else
        return [temp count];
}

- (NSInteger)tableView:(UITableView *)tv sectionForSectionIndexTitle:(NSString *)title atIndex:(NSInteger)index {
    NSInteger section = -1;
    if ([title isEqualToString:UITableViewIndexSearch]) {
        CGRect searchBarFrame = self.searchDisplayController.searchBar.frame;
        [tv scrollRectToVisible:searchBarFrame animated:NO];
    }
    else {
        
        section = index - 1;
    }
    return section;
}

- (NSArray *)sectionIndexTitlesForTableView:(UITableView *)tableView {
    
    NSArray *searchArray = [NSArray arrayWithObjects:
                            UITableViewIndexSearch,@"A", @"B", @"C", @"D", @"E", @"F", @"G", @"H", @"I", @"J", @"K", @"L",
                            @"M", @"N", @"O", @"P", @"Q", @"R", @"S", @"T", @"U", @"V", @"W", @"X", @"Y", @"Z", @"#", nil];
    if (searching) 
        return nil;
    else
        return searchArray;
    
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    
    NSArray *searchArray = [NSArray arrayWithObjects:
                            @"A", @"B", @"C", @"D", @"E", @"F", @"G", @"H", @"I", @"J", @"K", @"L",
                            @"M", @"N", @"O", @"P", @"Q", @"R", @"S", @"T", @"U", @"V", @"W", @"X", @"Y", @"Z", @"#", nil];
    
    if (searching) 
        return nil;
    else
        return [searchArray objectAtIndex:section];
    
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    static NSString *MyIdentifier = @"MyIdentifier";
	MyIdentifier = @"tblCellView";
	
	FilmTableCellView *cell = (FilmTableCellView *)[tableView dequeueReusableCellWithIdentifier:MyIdentifier];
	if(cell == nil) {
		[[NSBundle mainBundle] loadNibNamed:@"FilmTableCellView" owner:self options:nil];
		cell = tblCell;
	}
    
    if(searching){
        
        Film *film = [searchResults objectAtIndex:indexPath.row];
        
        [cell setTitleText:[NSString stringWithFormat:@"%@",film.filmName]];
        
        NSMutableString *formats = [NSMutableString stringWithFormat:@""];
        
        if (film.format_vhs != 0){
            [formats appendString:@"VHS "];
        }
        if (film.format_dvd != 0){
            [formats appendString:@"DVD "];
        }
        if (film.format_web != 0){
            [formats appendString:@"Web "];
        }
        if (film.format_blu != 0){
            [formats appendString:@"Blu-Ray "];
        }
        
        
        if (film.year != 0) {
            [cell  setYearText:[NSString stringWithFormat:@"Year:%d", film.year]];
            
        } else {
            [cell setYearText:[NSString stringWithFormat:@"Year:(Unknown)"]];
        }
        
        [cell setCover:[NSString stringWithFormat:@"%d",film.filmID]];
        
        [cell setCompanyText:film.companies];
        
    } else {
    
        NSMutableArray *temp = [films objectAtIndex:[indexPath section]];
    
        Film *film = [temp objectAtIndex:[indexPath row]];
    
        [cell setTitleText:[NSString stringWithFormat:@"%@",film.filmName]];
        
        NSMutableString *formats = [NSMutableString stringWithFormat:@""];
        
        if (film.format_vhs != 0){
            [formats appendString:@"VHS "];
        }
        if (film.format_dvd != 0){
            [formats appendString:@"DVD "];
        }
        if (film.format_web != 0){
            [formats appendString:@"Web "];
        }
        if (film.format_blu != 0){
            [formats appendString:@"Blu-Ray "];
        }
        
        
        if (film.year != 0) {
            [cell  setYearText:[NSString stringWithFormat:@"Year:%d", film.year]];
            
        } else {
            [cell setYearText:[NSString stringWithFormat:@"Year:(Unknown)"]];
        }
        
        [cell setCover:[NSString stringWithFormat:@"%d",film.filmID]];
        
        [cell setCompanyText:film.companies];
        
    }
    
    return cell;
}





- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (BOOL)searchDisplayController:(UISearchDisplayController *)controller shouldReloadTableForSearchString:(NSString *)searchString
{
    
    searching = YES;
    
    Film *temp;
    int searchLen = [searchString length];
    
    [searchResults removeAllObjects];
    
    
    for (temp in self.filmSearch) {
        
        
        //test length of film name before testing substring
        
        if (!(searchLen > [temp.filmName length])){
            
            if (!([searchString compare:[temp.filmName substringToIndex:searchLen] options:NSCaseInsensitiveSearch  ])) {
                
                [self.searchResults addObject:temp];
                
                
            }
        }
        
        
    }
    
    [self.searchDisplayController.searchResultsTableView reloadData];
 
    return NO;
    
}

- (void)searchDisplayController:(UISearchDisplayController *)controller willUnloadSearchResultsTableView:(UITableView *)tableView
{
    searching = NO;
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    return 60.0;
    
}



@end
