//
//  PeopleDetailController.m
//  BMXMDB
//
//  Created by Nick Hayday on 21/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "PeopleDetailController.h"

@implementation PeopleDetailController

@synthesize person, scrollView, personsFilms, riderView, activityView, spinner;

- (void)viewDidLoad {
    [super viewDidLoad];
    
    FMDBDataAccess *db = [[FMDBDataAccess alloc] init];
    
    self.personsFilms = [db getPersonsFilms:person.peopleID];
    
    self.title = person.peopleName;
    
}

- (void)viewWillAppear:(BOOL)animated {
    
    [super viewWillAppear:animated];
    
    spinner.hidesWhenStopped = YES;

    [spinner startAnimating];
    
    [riderView deselectRowAtIndexPath:[riderView indexPathForSelectedRow] animated:animated];
    
}

- (void)viewDidAppear:(BOOL)animated {
    
    CGRect tableFrame = riderView.frame;
    tableFrame.size.height = riderView.contentSize.height;
    riderView.frame = tableFrame;
    
    scrollView.contentSize = CGSizeMake(tableFrame.size.width, riderView.frame.origin.y + riderView.frame.size.height);
    
    scrollView.scrollsToTop = YES;
    riderView.scrollsToTop = NO;
    
    [spinner stopAnimating];
    [activityView setHidden:YES];
    
}



- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return [self.personsFilms count];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    
    NSMutableArray *temp = [self.personsFilms objectAtIndex:section];
    
    return [temp count];
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    
    NSArray *searchArray = [NSArray arrayWithObjects:
                            @"As Rider", @"As Editor", @"As Filmer", nil];
    
    
    return [searchArray objectAtIndex:section];
    
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    static NSString *MyIdentifier = @"MyIdentifier";
	MyIdentifier = @"filmTblCellView";
	
	PeopleFilmTableCellView *cell = (PeopleFilmTableCellView *)[tableView dequeueReusableCellWithIdentifier:MyIdentifier];
	if(cell == nil) {
		[[NSBundle mainBundle] loadNibNamed:@"PeopleFilmTableCellView" owner:self options:nil];
		cell = tblCell;
	}
    
    NSMutableArray *temp = [self.personsFilms objectAtIndex:[indexPath section]];
    
    Film *film = [temp objectAtIndex:[indexPath row]];
    
    [cell setTitleText:[NSString stringWithFormat:@"%@",film.filmName]];
    
    NSMutableString *formats = [NSMutableString stringWithFormat:@""];
    
    if (film.format_vhs != 0){
        [formats appendString:@"VHS "];
    }
    if (film.format_dvd != 0){
        [formats appendString:@"DVD "];
    }
    if (film.format_web != 0){
        [formats appendString:@"Web "];
    }
    if (film.format_blu != 0){
        [formats appendString:@"Blu-Ray "];
    }
    
    
    if (film.year != 0) {
        [cell  setYearText:[NSString stringWithFormat:@"Year:%d", film.year]];
        
    } else {
        [cell setYearText:[NSString stringWithFormat:@"Year:(Unknown)"]];
    }
    
    [cell setCover:[NSString stringWithFormat:@"%d",film.filmID]];
    
    [cell setCompanyText:film.companies];
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    FilmsDetailController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"FilmDetail"];
    
    NSMutableArray *temp = [self.personsFilms objectAtIndex:[indexPath section]];
    
    Film *film = [temp objectAtIndex:[indexPath row]];
    
    detail.film = film;
    
    [self.navigationController pushViewController:detail animated:YES];
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    return 60.0;
    
}




@end
