//
//  PeopleViewController.m
//  BMXMDB
//
//  Created by Nick Hayday on 21/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "PeopleViewController.h"

@implementation PeopleViewController

@synthesize people, peopleSearch, searchResults;

- (void)loadView {
    [super loadView];
    
    [self populatePeople];

}


- (void)viewDidLoad
{
    [super viewDidLoad];
//    [self populatePeople];
    
    self.tableView.contentOffset = CGPointMake(0.0, 44.0);
    
    self.navigationController.navigationBar.barStyle=UIBarStyleBlackOpaque;
    
    searching = NO;

}

-(void) populatePeople 
{
    self.people = [[NSMutableArray alloc] init];
    self.searchResults = [[NSMutableArray alloc] init];
    
    FMDBDataAccess *db = [[FMDBDataAccess alloc] init];
    
    self.people = [db getSectionedPeople];
    
    self.peopleSearch = [db getPeople];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    if (searching)
		return 1;
	else
        return [self.people count];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    PeopleDetailController *detail = [self.storyboard instantiateViewControllerWithIdentifier:@"PeopleDetail"];
    
    NSMutableArray *section = [self.people objectAtIndex:indexPath.section];
    
    People *p;
    
    if (searching){
        p = [searchResults objectAtIndex:indexPath.row];
    }else {
        p = [section objectAtIndex:indexPath.row];
    }
    
    detail.person = p;
    
    [self.navigationController pushViewController:detail animated:YES];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    
    NSMutableArray *temp = [self.people objectAtIndex:section];
    
    
    if (searching)
		return [searchResults count];
	else
        return [temp count];
}

- (NSInteger)tableView:(UITableView *)tv sectionForSectionIndexTitle:(NSString *)title atIndex:(NSInteger)index {
    NSInteger section = -1;
    if ([title isEqualToString:UITableViewIndexSearch]) {
        CGRect searchBarFrame = self.searchDisplayController.searchBar.frame;
        [tv scrollRectToVisible:searchBarFrame animated:NO];
    }
    else {
        
        section = index - 1;
    }
    return section;
}

- (NSArray *)sectionIndexTitlesForTableView:(UITableView *)tableView {
    
    NSArray *searchArray = [NSArray arrayWithObjects:
                            UITableViewIndexSearch,@"A", @"B", @"C", @"D", @"E", @"F", @"G", @"H", @"I", @"J", @"K", @"L",
                            @"M", @"N", @"O", @"P", @"Q", @"R", @"S", @"T", @"U", @"V", @"W", @"X", @"Y", @"Z", @"#", nil];
    if (searching) 
        return nil;
    else
        return searchArray;
    
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    
    NSArray *searchArray = [NSArray arrayWithObjects:
                            @"A", @"B", @"C", @"D", @"E", @"F", @"G", @"H", @"I", @"J", @"K", @"L",
                            @"M", @"N", @"O", @"P", @"Q", @"R", @"S", @"T", @"U", @"V", @"W", @"X", @"Y", @"Z", @"#", nil];
    
    if (searching) 
        return nil;
    else
        return [searchArray objectAtIndex:section];
    
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"PeopleCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }

    
    if(searching){
        
        //        change to Film object when we're adding the right kind of objects to the array
        
        People *temp2 = [searchResults objectAtIndex:indexPath.row];
        
        [[cell textLabel] setText:[temp2 peopleName]];
        
		
    } else {

    
        NSMutableArray *temp = [self.people objectAtIndex:[indexPath section]];
        
        People *person = [temp objectAtIndex:[indexPath row]];
    
        [[cell textLabel] setText:[NSString stringWithFormat:@"%@",person.peopleName]];
        
    }
    
    return cell;
}

- (BOOL)searchDisplayController:(UISearchDisplayController *)controller shouldReloadTableForSearchString:(NSString *)searchString
{
    
    searching = YES;

    People *temp;
    int searchLen = [searchString length];
    
    [searchResults removeAllObjects];
    
    
    for (temp in self.peopleSearch) {
        
        
        //test length of film name before testing substring
        
        if (!(searchLen > [temp.peopleName length])){
            
            if (!([searchString compare:[temp.peopleName substringToIndex:searchLen] options:NSCaseInsensitiveSearch  ])) {
                
                [self.searchResults addObject:temp];
                
                
            }
        }
        
        
    }
    
    [self.searchDisplayController.searchResultsTableView reloadData];
    
    return NO;
    
}

- (void)searchDisplayController:(UISearchDisplayController *)controller willUnloadSearchResultsTableView:(UITableView *)tableView
{
    searching = NO;
    
}



@end
