//
//  TabViewController.m
//  bmxmdb
//
//  Created by Nick Hayday on 16/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "TabViewController.h"
#import "FilmSectionViewController.h"
#import "HomeDetailViewController.h"
#import "Reachability.h"
#import "MBProgressHUD.h"

@implementation TabViewController


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	if([(UINavigationController *)self.selectedViewController isKindOfClass:[UINavigationController class]])
		if([[(UINavigationController *)self.selectedViewController visibleViewController] isKindOfClass:[FilmSectionViewController class]]  || [[(UINavigationController *)self.selectedViewController visibleViewController] isKindOfClass:[HomeDetailViewController class]])
			return (interfaceOrientation == UIInterfaceOrientationPortrait ||interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight);
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)viewDidLoad {
    //Re order tabs
    NSMutableArray *orderedTabs = [[NSMutableArray alloc] init];
    
    [orderedTabs insertObject:@"0" atIndex:0];
    [orderedTabs insertObject:@"1" atIndex:1];
    [orderedTabs insertObject:@"2" atIndex:2];
    [orderedTabs insertObject:@"3" atIndex:3];
    
    for (UINavigationController *aController in self.viewControllers) {
        
        
        if ([aController.topViewController.tabBarItem.title isEqualToString:@"Home"]){
            [orderedTabs replaceObjectAtIndex:0 withObject:aController];
        }
        
        if ([aController.topViewController.tabBarItem.title isEqualToString:@"Films"]){
            [orderedTabs replaceObjectAtIndex:1 withObject:aController];
        }
        
        if ([aController.topViewController.tabBarItem.title isEqualToString:@"People"]){
            [orderedTabs replaceObjectAtIndex:2 withObject:aController];
        }
        
        if ([aController.topViewController.tabBarItem.title isEqualToString:@"Companies"]){
            [orderedTabs replaceObjectAtIndex:3 withObject:aController];
        }
        
    }
    
    self.viewControllers = orderedTabs;
    
    [[UITabBar appearance] setSelectedImageTintColor:[UIColor redColor]];
    
    
    //Pre load data
    for (UINavigationController *navCont in self.viewControllers) { //nav controllers inside the tab bar
        
        for (id test in navCont.childViewControllers) { //TableViewControllers inside the nav controllers
                [test view];
        }
    }
    
    [[NSNotificationCenter defaultCenter] addObserver:self 
                                             selector:@selector(reachabilityChanged:) 
                                                 name:kReachabilityChangedNotification 
                                               object:nil];
    
    Reachability * reach = [Reachability reachabilityWithHostname:@"bmxmdb.com"];
    
    [reach startNotifier];
    
        
}

-(void)reachabilityChanged:(NSNotification*)note
{
    Reachability * reach = [note object];
    
    if([reach isReachable])
    {
        
    }
    else
    {
        
                MBProgressHUD *hud = [MBProgressHUD showHUDAddedTo:self.view animated:YES];
                hud.mode = MBProgressHUDModeText;
                hud.labelText = @"No Internet connection available.";
                hud.detailsLabelText = @"Browsing film details is still available.";
                hud.margin = 10.f;
                hud.removeFromSuperViewOnHide = YES;
                
                [hud hide:YES afterDelay:1.5];
        
    }
}






@end
